/*
 * Modified Mickey, for home use
 *
 * Assignment 0 - Mouse
 * Modified from:
 *
 *  Smiley
 *  ------
 *  This program draws a smiley inside a window. It uses a drawing
 *  area with a redraw call-back function to ensure the smile is
 *  always drawn.
 *
 *  Note there is a problem with this program: if you resize the
 *  window to be too small, it hangs there forever. Why?
 *  The answer is in the drawarc function drawing the smile.
 *  If the face rectangle r1 gets too small, r2 (which is r1 inset
 *  by 30 pixels) gets a negative width and/or height.
 *
 *  Negative-sized rectangles are no good. The computer hardware
 *  treats rectangle widths and heights as unsigned integers.
 *  A negative number when cast to an unsigned int becomes very large
 *  indeed. The graphics hardware is then trying to draw an impossibly
 *  large arc, hence the program sits there drawing for a long time.
 *
 *  Solution? Add this line before drawarc: r2 = rcanon(r2);
 *  The rcanon function corrects for negative widths and/or heights
 *  and makes them positive again, while preserving the size of the
 *  rectangle.
 */

#define PIXSIZE 128

#include "graphapp.h"

int wid;

rect scalerect(int x, int y, int w, int h) {
	return(initrect(x * wid / PIXSIZE, y * wid / PIXSIZE,
		w * wid / PIXSIZE, h * wid / PIXSIZE));
}

point scalept(int x, int y) {
	return(pt(x * wid / PIXSIZE, y * wid / PIXSIZE));
}

int main()
{
	rect ear1;
	point p;
	rect ear2;
	rect face;
	rect snouttop;
	rect snoutbottom;
	rect nose;
	rect smile;
	rect eye;
	point p1, p2;
	point hair[8];
	int i;
	rect r;

	r = initrect(0, 0, 200, 200);

	init();
	wid = r.width;
	setcolour(Black);
	setlinewidth(wid / 100 + 1);

	ear1 = scalerect(24, 12, 32, 32);
	fillellipse(ear1);

	ear2 = scalerect(16, 60, 32, 32);
	fillellipse(ear2);

	face = scalerect(40, 32, 56, 56);
	drawarc(face, 40, 327);

	snouttop = scalerect(84, 40, 20, 20);
	drawarc(snouttop, 0, 160);

	snoutbottom = scalerect(43, 30, 60, 50);
	drawarc(snoutbottom, 305, 365);
	
	smile = scalerect(50, 32, 50, 50);
	drawarc(smile, 200, 270);

	drawline(scalept(102, 53), scalept(103, 49));

	nose = scalerect(90, 32, 10, 16);
	fillellipse(nose);

	for(i=0; i<=3; i++) {
		eye = scalerect(70+i, 40+2*i, 7, 7);
		fillellipse(eye);

		eye = scalerect(80+i, 35+2*i, 5, 7);
		fillellipse(eye);
	}

	hair[0] = scalept(42, 50);
	hair[1] = scalept(40, 65);
	hair[2] = scalept(45, 58);
	hair[3] = scalept(50, 55);
	hair[4] = scalept(57, 56);
	hair[5] = scalept(66, 60);
	hair[6] = scalept(55, 48);
	hair[7] = scalept(48, 32);
	fillpolygon(hair, 8);
	getchar();
}
