#include <time.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <pc.h>
#include <stdarg.h>
#include "blin.h"
#include "yuck.h"

#define point(x, y) img[(y)*swidth + (x)]
#define inimage(x, y) (x-ox) >= 0 && (x-ox) < picx && (y-oy) >= 0 && \
(y-oy) < picy
#define inpalette(x, y) y >= paly && y <= paly + 3 * 4

//prototypes
void drawpalette(void);
void copybrush(byte b[], int x, int y);
void pastebrush(byte b[], int x, int y);
void parsecomment(void);
void border(void);
void loadimage(char *filename);
void brushdown(int x, int y, byte c);
void saveimage(char *filename);
void handlemouse(mouse_event *me);
void handlekey(char);
void plot(int x, int y, byte c);
void plasma(int x1, int y1, int x2, int y2);
void randcolour(byte c[3], double a);
void readin(char *s, void *f, char *format, ...);

enum {
	paly = 170,
	swidth = 320,
	sheight = 200,
	palsize = 768
};

byte img[swidth * sheight];
int ox, oy;
int forecol, backcol;
int brush, brush2;
char quitflag;
char curcomp;
FILE *infile;
int picx = 128;
int picy = 128;

int main() {
	byte c[3];
	int i, j;
	int addr;
	byte bak[128*128];
	mouse_event me;

	ox = oy = 10;
	quitflag = 0;
	forecol = 255;
	backcol = 0;
	curcomp = 0;
	brush = 1;
	brush2 = brush / 2;
	initgraphics();

	for (i=0; i<swidth * sheight; i++) img[i] = 0;
	border();
	drawpalette();

	drawimage(img);

	//oldx = me.x;
	//oldy = me.y;

	while(!quitflag) {
		pollmouse(&me);
		if (inimage(me.x, me.y)) {
			copybrush(bak, me.x, me.y);
			brushdown(me.x, me.y, forecol);
			drawimage(img);
			pastebrush(bak, me.x, me.y);
		} else {
			bak[0] = point(me.x, me.y);
			plot(me.x, me.y, forecol);
			drawimage(img);
			plot(me.x, me.y, bak[0]);
		}

		if (me.button) {
			handlemouse(&me);
		}
		if (kbhit()) {
			handlekey(getch());
		}
	}

	settextmode();

	return(0);
}

void handlemouse(mouse_event *me) {
	switch(me->button) {
		case 1:
			if (inimage(me->x, me->y)) {
				brushdown(me->x, me->y, forecol);
			} else if (inpalette(me->x, me->y)) {
				forecol = point(me->x, me->y);
			}
			break;
		case 2:
			if (inimage(me->x, me->y)) {
				brushdown(me->x, me->y, backcol);
			} else if (inpalette(me->x, me->y)) {
				backcol = point(me->x, me->y);
			}
			break;
		default:
			break;
	}

}

void handlekey(char ch) {
	int i, j, c;
	char filename[80];

	switch(ch) {
		case 27:
			quitflag = 1;
			break;
		case 'L':
			gotoxy(1, 20);
			printf("Load: ");
			scanf("%s", filename);
			loadimage(filename);
			break;
		case 'S':
			gotoxy(1, 20);
			printf("Save to: ");
			scanf("%s", filename);
			saveimage(filename);
			break;

		case '0':
			forecol = 255;
			break;

		case '1':
			forecol = nextcol(0, forecol);
			break;
		case 'q':
			forecol = prevcol(0, forecol);
			break;
		case '2':
			forecol = nextcol(1, forecol);
			break;
		case 'w':
			forecol = prevcol(1, forecol);
			break;
		case '3':
			forecol = nextcol(2, forecol);
			break;
		case 'e':
			forecol = prevcol(2, forecol);
			break;
		case ']':
			brush ++;
			brush2 = brush / 2;
			break;
		case '[':
			brush --;
			brush2 = brush / 2;
			break;

		case ',':
			for (j=oy; j<oy+picy; j++) {
				c = point(ox, j);
				for (i=ox; i<ox+picx-1; i++) {
					point(i, j) = point(i + 1, j);
				}
				point(ox+picx-1, j) = c;
			}
			break;
		case '.':
			for (j=oy; j<oy+picy; j++) {
				c = point(ox+picx-1, j);
				for (i=ox+picx-1; i>ox; i--) {
					point(i, j) = point(i - 1, j);
				}
				point(ox, j) = c;
			}
			break;

		case 'C':
			for (j=oy; j<oy+picy; j++) {
				for (i=ox; i<ox+picx; i++) {
					point(i, j) = backcol;
				}
			}
			break;

		default:
			break;

	}
}

void plasma(int x1, int y1, int x2, int y2) {
	byte c11[3], c12[3];
	byte c21[3], c22[3];
	byte c[3];
	int xm, ym;
	int i;
	double xd;

	if (x2 - x1 <= 1 && y2 - y1 <= 1) return;
	c2rgb(img[y1 * swidth + x1], c11);
	c2rgb(img[y2 * swidth + x1], c12);
	//printf(": %d\n", c12[2]);
	c2rgb(img[y1 * swidth + x2], c21);
	c2rgb(img[y2 * swidth + x2], c22);

	xm = (x2 + x1) / 2;
	ym = (y2 + y1) / 2;

	xd = 1.0 * (x2 - x1) / picx;
	xd *= xd;
	xd *= xd;
	xd *= 0.5;

	for (i=0; i<3; i++) c[i] = (c11[i] + c12[i] + c21[i] + c22[i]) / 4;
	randcolour(c, xd);
	plot(xm, ym, rgb2c(c));

	if (ym > y1) {
		for (i=0; i<3; i++) c[i] = (c11[i] + c12[i]) / 2;
		randcolour(c, xd);
		plot(x1, ym, rgb2c(c));
		for (i=0; i<3; i++) c[i] = (c21[i] + c22[i]) / 2;
		randcolour(c, xd);
		plot(x2, ym, rgb2c(c));
	}
	if (xm > x1) {
		for (i=0; i<3; i++) c[i] = (c11[i] + c21[i]) / 2;
		randcolour(c, xd);
		plot(xm, y1, rgb2c(c));
		for (i=0; i<3; i++) c[i] = (c12[i] + c22[i]) / 2;
		randcolour(c, xd);
		plot(xm, y2, rgb2c(c));
	}

	plasma(x1, y1, xm, ym);
	plasma(xm, y1, x2, ym);
	plasma(x1, ym, xm, y2);
	plasma(xm, ym, x2, y2);
}

void randcolour(byte c[3], double a) {
	int i, temp[3];

	temp[0] = c[0];
	temp[1] = c[1];
	temp[2] = c[2];

	for (i=0; i<= 64 * a; i++) {
		temp[0] += rand() % 3 - 1;
		temp[1] += rand() % 3 - 1;
		temp[2] += rand() % 5 - 2;
	}

	if (temp[0] < 0) temp[0] = 0;
	if (temp[1] < 1) temp[1] = 1;
	if (temp[2] < 2) temp[2] = 2;

	if (temp[0] > 63) temp[0] = 63;
	if (temp[1] > 63) temp[1] = 63;
	if (temp[2] > 63) temp[2] = 63;

	c[0] = (byte) temp[0];
	c[1] = (byte) temp[1];
	c[2] = (byte) temp[2];
}

void plot(int x, int y, byte c) {
	img[y * swidth + x] = c;
}

void loadimage(char *filename) {
	int i, j;
	int c;

	if (!(infile = fopen(filename, "r"))) {
		perror("fopen");
		exit(1);
	}

	// Clear old image
	for (i=-1; i<=picy; i++) {
		for (j=-1; j<=picx; j++) {
			img[(i + oy) * swidth + j + ox] = 0;
		}
	}

	readin("%d", &picx, "texture size x");
	readin("%d", &picy, "texture size y");

	border();

	for (i=0; i<picy; i++) {
		for (j=0; j<picx; j++) {
			readin("%d", &c, "texel %d, %d", j, i);
			img[(i + oy) * swidth + j + ox] = (byte) c;
		}
	}

	drawimage(img);

}

void saveimage(char *filename) {
	int i, j;
	FILE *fp;

	if (!(fp = fopen(filename, "w"))) {
		perror("fopen");
		exit(1);
	}

	fprintf(fp, "// Bitmap generated by plasma.c\n");
	fprintf(fp, "%d %d\n", picx, picy);
	for (i=0; i<picy; i++) {
		for (j=0; j<picx; j++) {
			fprintf(fp, "%d\n", img[(i + oy) * swidth + j + ox]);
		}
	}
}

void brushdown(int x, int y, byte c) {
	int i, j;

	for (i=x-brush2; i<=x-brush2+brush; i++) {
		for (j=y-brush2; j<=y-brush2+brush; j++) {
			if (inimage(i, j)) {
				plot(i, j, c);
			}
		}
	}
}

void copybrush(byte b[], int x, int y) {
	int i, j;
	int n;

	n = 0;
	for (i=x-brush2; i<=x-brush2+brush; i++) {
		for (j=y-brush2; j<=y-brush2+brush; j++) {
			b[n++] = img[j*swidth + i];
		}
	}
}

void pastebrush(byte b[], int x, int y) {
	int i, j;
	int n;

	n = 0;
	for (i=x-brush2; i<=x-brush2+brush; i++) {
		for (j=y-brush2; j<=y-brush2+brush; j++) {
			img[j*swidth + i] = b[n++];
		}
	}
}

void readin(char *s, void *f, char *format, ...) {
	va_list arg;
	char done;
	int check;
	char ch;

	done = 0;
	do {
		if (feof(infile)) {
			va_start(arg, format);
			fprintf(stderr, "Unexpected end of file.\nError reading ");
			vfprintf(stderr, format, arg);
			fprintf(stderr, "\n");
			va_end(arg);
			exit(1);
		}

		fscanf(infile, " %c", &ch);
		if (ch == '/') {
			parsecomment();
		} else {
			ungetc(ch, infile);
			check = fscanf(infile, s, f);
			if (!check) {
				va_start(arg, format);
				fprintf(stderr, "Error reading ");
				vfprintf(stderr, format, arg);
				fprintf(stderr, "\n");
				va_end(arg);
				exit(1);
			}
			//printf("Read %s\n", thing);
			done++;
		}
	} while (!done);
}

void border(void) {
	int i;

	for (i=ox-1; i<ox+picx+1; i++) {
		img[swidth*(oy-1) + i] = 255;
		img[swidth*(oy+picy) + i] = 255;
	}

	for (i=oy; i<oy+picy; i++) {
		img[swidth*i + ox - 1] = 255;
		img[swidth*i + ox + picx] = 255;
	}

}

void parsecomment(void) {
	char ch;
	char flag;

	if ((ch = getc(infile) == '/')) {
		while ((ch = getc(infile) != '\n'));
		return;
	} else if ((ch = getc(infile)) != '*') {
		fprintf(stderr, "Warning: bad comment\n");
	}
	flag = 0;
	do {
		do {
			ch = getc(infile);
		} while (ch != '*');
		if ((ch = getc(infile)) == '/') {
			flag++;
		}
	} while (!flag);
}

void drawpalette(void) {
	int i, j, x, y;

	for (i=0; i<4; i++) {
		for (j=0; j<256/4; j++) {
			for (y=paly+i*3; y<paly+i*3+3; y++) {
				for (x=swidth*j/64; x<swidth*(j+1)/64; x++) {
					plot(x, y, i*64+j);
				}
			}
		}
	}
}
